.extern print_lcd

.equ STACK_LIMIT,     0xC00	/* 3K */
.equ IRQ_STACK_SIZE,  (4*4)


/*
settings:
31 30 29 28 27 26 25 24
          BA
23 22 21 20 19 18 17 16
    BA      -  -  -  -
15 14  13    12   11 10 9  8
-  -   CSEN  BAT  TDF      PAGES
7      6  5    4 3 2     1 0
PAGES    WSE  NWS       DBW

/* for Mem-Ctrl */
.equ	EBI_BASE,0xFFE00000

/* Adress and CFG NSC0 (FLASH) */
/*.equ EBI_CSR0 ,0x010026A5	/* Flash at 0x0100,0000, 4MB, 3 cycles added after transfer, 16 bits, 3 WS */
.equ EBI_CSR0 ,0x01002529

/* Adress and CFG NSC1 (SRAM) */
/*.equ EBI_CSR1 ,0x020022A1	/* SRAM at 0x0200.0000, 4MB,  1 cycles added after transfer, 16-bit, 1 wait state */
.equ EBI_CSR1 ,0x02002121

/* Adress and CFG NSC2 (SRAM) */
/*.equ EBI_CSR2 ,0x028020A1	/* 0x02800000, 4MB,  0 cycles added after transfer, 16-bit, 1 wait state */
/*.equ EBI_CSR2 ,0x02800000	/* 0x02800000, 4MB,  0 cycles added after transfer, 16-bit, 1 wait state */
.equ EBI_CSR2 ,0x20000000	/* unused */

/* for LCD or PIO_8255 on CS3*/
/*.equ EBI_CSR3 ,0x03002426 */
.equ EBI_CSR3 ,0x03002426


.equ GPMC_BASE ,0xFFFF4000
.equ PMC_SCER ,0x0   /* System Clock Enable  Register */
.equ PMC_SCDR ,0x4   /* System Clock Disable Register */
.equ PMC_SCSR ,0x8   /* System Clock Status  Register */
/* Reserved0 0xC*/
.equ PMC_PCER ,0x10  /* Peripheral Clock Enable  Register */
.equ PMC_PCDR ,0x14  /* Peripheral Clock Disable Register */
.equ PMC_PCSR ,0x18  /* Peripheral Clock Status  Register */

.equ PMC_PIOAB , 0x6000

/* Power Management Controller Base Address */
.equ APMC_BASE  ,     0xFFFF4000

.equ APMC_CGMR  ,       0x20       /* - Clock Generator Mode Register */
.equ APMC_SR    ,       0x30       /* - Status Register */
.equ APMC_MOSCS     ,     0x1     /*- Main Osillator Status */
.equ APMC_PLL_LOCK  ,     0x2     /*- PLL Lock Status */

/* invert LED-pegel */
#define INVERTING 


.equ GPIOA_BASE , 0xFFFEC000  /* PORT A */
.equ GPIOB_BASE , 0xFFFF0000  /* PORT B */
.equ PIO_PER , 0x00           /* PIO Enable Register */
.equ PIO_PDR , 0x04           /* PIO Disable Register */
.equ PIO_PSR , 0x08           /* PIO Status Register */
	/* .equ Reserved0, 0xC */
.equ PIO_OER , 0x10           /* Output Enable Register */
.equ PIO_ODR , 0x14           /* Output Disable Register */
.equ PIO_OSR , 0x18           /* Output Status Register */
	/* .equ Reserved1, 0x1C */
.equ PIO_IFER , 0x20          /* Input Filter Enable Register */
.equ PIO_IFDR , 0x24          /* Input Filter Disable Register */
.equ PIO_IFSR , 0x28          /* Input Filter Status Register */
	/* .equ Reserved2, 0x2C */

#ifdef INVERTING
	.equ PIO_SODR , 0x30          /* Set Output Data Register */
	.equ PIO_CODR , 0x34          /* Clear Output Data Register */
#elsif
	.equ PIO_SODR , 0x34          /* Set Output Data Register */
	.equ PIO_CODR , 0x30          /* Clear Output Data Register */
#endif
.equ PIO_ODSR , 0x38          /* Output Data Status Register */
.equ PIO_PDSR , 0x3C          /* Pin Data Status Register */
.equ PIO_IER , 0x40           /* Interrupt Enable Register */
.equ PIO_IDR , 0x44           /* Interrupt Disable Register */
.equ PIO_IMR , 0x48           /* Interrupt Mask Register */
.equ PIO_ISR , 0x4C           /* Interrupt Status Register */
   /* PIO_MDER, 0x50: Multi Driver Enable Register */
.equ PIO_MDDR , 0x54   	      /* PIO_MDDR: Multi Driver Disable Register */
   /* PIO_MDSR, 0x58: Multi Driver Status Register */


.equ LEDA , 0x04000000	/*PB26*/
.equ LEDB , 0x08000000  /*PA27*/
.equ LEDC , 0x10000000  /*PA28*/
.equ LEDD , 0x20000000  /*PA29*/

.equ LED1 , 0x00000100  /*PB8*/
.equ LED2 , 0x00000200  /*PB9*/
.equ LED3 , 0x00000400  /*PB10*/
.equ LED4 , 0x00000800  /*PB11*/
.equ LED5 , 0x00001000  /*PB12*/
.equ LED6 , 0x00002000  /*PB13*/
.equ LED7 , 0x00004000  /*PB14*/
.equ LED8 , 0x00008000  /*PB15*/

.equ KEYA_S1  , 0x00000200  /*PA9*/
.equ KEYB_S2  , 0x00010000  /*PB16*/
.equ KEYB_S3  , 0x00080000  /*PB19*/
.equ KEYB_S4  , 0x00100000  /*PB20*/

.equ ALL_ALEDS , LEDB|LEDC|LEDD
.equ ALL_AKEYS , KEYA_S1
.equ ALL_APIOS , LEDB|LEDC|LEDD|KEYA_S1

.equ ALL_BLEDS , LEDA|LED1|LED2|LED3|LED4|LED5|LED6|LED7|LED8
.equ ALL_BKEYS , KEYB_S2|KEYB_S3|KEYB_S4
.equ ALL_BPIOS , LEDA|LED1|LED2|LED3|LED4|LED5|LED6|LED7|LED8|KEYB_S2|KEYB_S3|KEYB_S4

.equ CNT_MAX, 0x10000

/* ##################################################################### */

	.global	__main
__main:	
copy_start:
	b resetvec
	b undefined_instruction
	b software_interrupt
	b prefetch_abort
	b data_abort
	b not_used
	b irq
	b fiq

/* ##################################################################### */
/* ##################################################################### */

undefined_instruction:
	mov 	r6,pc
	mov	r3, #LEDA
	b	my_LedCode
software_interrupt:
	/*mov pc, lr	jump back */
	mov 	r6,pc
	mov	r3, #LEDB
	b	my_LedCode
prefetch_abort:
	mov 	r6,pc
	mov	r3, #LEDC
	b	my_LedCode
data_abort:
	mov 	r6,pc
	mov	r3, #LEDD
	b	my_LedCode
not_used:
	mov 	r6,pc
	mov	r3, #LEDA|LEDB
	b	my_LedCode
irq:
	mov 	r6,pc
	mov	r3, #LEDB|LEDC
	b	my_LedCode
fiq:
	mov 	r6,pc
	mov	r3, #LEDC|LEDD
	b	my_LedCode

/* ##################################################################### */
/* busy asm_wait loop, clobbers r2*/
my_asm_wait:	
	mov	r2, #0x60000
my_asm_wait0:
	subs	r2, r2, #1
	bne	my_asm_wait0
	mov	pc, lr

/* ##################################################################### */
/* turn LED on. clobbers r0 and r1 */
my_led_on:
	ldr	r0, =GPIOA_BASE
	str	r1, [r0, #PIO_SODR]
	mov	pc, lr

/* ##################################################################### */
/* turn LED off. clobbers r0 - r2 */
my_led_off:
	ldr	r0, =GPIOA_BASE
	str	r1, [r0, #PIO_CODR]
	mov	pc, lr


/* ##################################################################### */
my_blink:
	mov r4, lr
	mov	r1,r3
	bl 	my_led_on
	bl 	my_asm_wait
	mov	r1,r3
	bl 	my_led_off
	bl 	my_asm_wait
	mov	pc, r4

/* ##################################################################### */
my_LedCode:
	ldr	r0, =GPIOA_BASE
	mov	r1, #LEDA|LEDB|LEDC|LEDD
	str	r1, [r0, #PIO_OER]		
my_LedCode0:
	mov	r1,r3
	bl 	my_blink
	b	my_LedCode0

copy_end:


/* ##################################################################### */

.global resetvec
resetvec:
	mov	sp,#0x400

low_level_init:
	/* - Speed up the System Frequency 
	   - from 32KHz to 16MHz and last upto 32MHz
	BITs for #APMC_CGMR:
	--pppppp	PllCount (0)
	oooooooo	OsCount (2F)
	ccmmmmmm	CSS ('00' RTC / '01' Main osz. / '10' phase lock loop)   MUL (000000 --> PLL deactivated)
	-sca-deb	- Pre[sca]ler (000) - MCKO[D]S (0) MOSC[E]N (1)  MOSK[B]YP (0=crystal 1 -->xin)
	*/

                ldr     r0, =0x002F0002             /* MOSCEN = 1, OSCOUNT = 47  (1.4ms/30s) */
                ldr     r1, =APMC_BASE              /* Get the APMC Base Address */
                str     r0, [r1, #APMC_CGMR]        /* Store the configuration of the Clock Generator */

	/* - Reading the APMC Status register to detect when the oscillator is stabilized */
                mov     r4, #APMC_MOSCS
MoscsLoop:
                ldr     r2, [r1, #APMC_SR]
                and     r2, r4,r2
                cmp     r2, #APMC_MOSCS
                bne     MoscsLoop

	/* - Commuting from Slow Clock to Main Oscillator (16Mhz) */
                ldr     r0, =0x002F4002             /* use 16MHz on X-Pins, MUL ==> 16MHz*1 */
                str     r0, [r1, #APMC_CGMR]        /* Store the configuration of the Clock Generator */

	/* -Setup the PLL */
                ldr     r0, =0x032F4102             /* PLLCOUNT = 3, use 16MHz on X-Pins, MUL ==> 16MHz*2 */
                str     r0, [r1, #APMC_CGMR]        /* Store the configuration of the Clock Generator */

	/* - Reading the APMC Status register to detect when the PLL is stabilized */
                mov     r4, #APMC_PLL_LOCK
Pll_Loop:
                ldr     r2, [r1, #APMC_SR]
                and     r2, r4,r2
                cmp     r2, #APMC_PLL_LOCK
                bne     Pll_Loop

	/* - Commuting from 16Mhz to PLL @ 32MHz */
                ldr     r0, =0x032F8102             /* phase lock loop, MUL = 1 */
                str     r0, [r1, #APMC_CGMR]        /* Store the configuration of the Clock Generator */

	/* - Now the Master clock is the output of PLL @ 32MHz */

/* copy into RAM before remapping */
    mov     r0, #0
    mov     r1, #copy_end-copy_start
    mov     r2, #0x300000
CopyLoop:
    ldr     r10, [r0], #4
    str     r10, [r2], #4
    cmp     r0, r1      
    blo     CopyLoop

/* Remapping now */
	ldr	r10,=InitTableEBI		/* get the address of the chip select register image */
	movs	r0, pc, LSR #20		/* pc > 0x100000 */
	moveq	r10, r10, LSL #12	/* Mask the 12 highest bits of the address */
	moveq	r10, r10, LSR #12
	
	/* Copy Chip Select Register Image to Memory Controller and command remap */
	ldmia	r10!, {r0-r9,r11-r12}	/* load the complete image and the EBI base */
	stmia	r11!, {r0-r9}           /* store the complete image with the remap command */
	mov	pc, r12                 /* jump and break the pipeline */


        /* Put constant table here. */

/* EBI initialization table */
/* ##################################################################### */
InitTableEBI:
	.long	EBI_CSR0		/* 0x01000000, 16MB, 0 hold, 16 bits, 8 WS */
	.long	EBI_CSR1		/* 0x02000000, 16MB, 0 hold, 16 bits, 1 WS, Byte Select access */
	.long	EBI_CSR2		/* unused */
	.long	EBI_CSR3		/* CS3*/
	.long	0x40000000		/* unused */
	.long	0x50000000		/* unused */
	.long	0x60000000		/* unused */
	.long	0x70000000		/* unused */
	.long	0x00000001		/* REMAP command */
	.long	0x00000006		/* 7 memory regions, standard read */
	.long	EBI_BASE		/* EBI Base address */
	.long 	AfterReMap


/* ##################################################################### */

blinkA:
	mov r4, lr
	ldr	r0, =GPIOA_BASE
	mov	r1,r3
	bl 	led_on
	bl 	asm_wait
	mov	r1,r3
	bl 	led_off
	mov	pc, r4

/* ##################################################################### */
blinkB:
	ldr	r0, =GPIOB_BASE
	mov r4, lr
	mov	r1,r3
	bl 	led_off
	bl 	asm_wait
	mov	r1,r3
	bl 	led_on
	mov	pc, r4


/* ##################################################################### */
/* turn LED on. clobbers r0 and r1 */
led_on:
	str	r1, [r0, #PIO_SODR]
	mov	pc, lr

/* ##################################################################### */
/* turn LED off. clobbers r0 - r2 */
led_off:
	str	r1, [r0, #PIO_CODR]
	mov	pc, lr

/* ##################################################################### */
/* busy asm_wait loop, clobbers r2*/
.global	asm_shortwait
asm_shortwait:
	mov	r2, #0x40000
	b asm_wait0 
.global	asm_wait
asm_wait:	
	mov	r2, #0x80000
asm_wait0:
	subs	r2, r2, #1
	bne	asm_wait0
	mov	pc, lr

/* ##################################################################### */
Clear4Leds:
	mov r4, lr
	ldr	r0, =GPIOB_BASE
	ldr	r1, =LEDA
	bl 	led_off

	ldr	r0, =GPIOA_BASE
	ldr	r1, =ALL_ALEDS
	bl 	led_off
	mov	pc, r4


/* ##################################################################### */
AfterReMap:

/* enable PIO-Clock */
	ldr	r0, =GPMC_BASE
	ldr r2, [r0, #PMC_PCER] /* Peripheral Clock Enable */
	orr r2, r2, #PMC_PIOAB  /* port a+b */
	str	r2, [r0, #PMC_PCER]
/* init ports */
	ldr	r0, =GPIOA_BASE
	mov	r1, #0xFFFFFFFF
	str	r1, [r0, #PIO_IDR]	/* intr disable */		
	str	r1, [r0, #PIO_MDDR]	/* open drain disable */	
	str	r1, [r0, #PIO_ODR]  /* output disable */
	str	r1, [r0, #PIO_IFDR] /* input filter disable*/
	str	r1, [r0, #PIO_PDR]	/* PIO disable */
	ldr	r1, =ALL_AKEYS
	str	r1, [r0, #PIO_IFER] /* input filter */
	ldr	r1, =ALL_ALEDS
	str	r1, [r0, #PIO_OER]	/* output */
	ldr	r1, =ALL_APIOS
	str	r1, [r0, #PIO_PER]	/* PIO Enable */


	ldr	r0, =GPIOB_BASE
	mov	r1, #0xFFFFFFFF
	str	r1, [r0, #PIO_IDR]	/* intr disable */		
	str	r1, [r0, #PIO_MDDR]	/* open drain disable */	
	str	r1, [r0, #PIO_ODR]  /* output disable */
	str	r1, [r0, #PIO_IFDR] /* input filter disable*/
	str	r1, [r0, #PIO_PDR]	/* PIO disable */
	ldr	r1, =ALL_BKEYS
	str	r1, [r0, #PIO_IFER] /* input filter */
	ldr	r1, =ALL_BLEDS
	str	r1, [r0, #PIO_OER]	/* output */
	ldr	r1, =ALL_BPIOS
	str	r1, [r0, #PIO_PER]	/* PIO Enable */

/* turn all Leds off */
	bl Clear4Leds
	ldr	r0, =GPIOB_BASE
	ldr	r1, =0x0000FF00
	bl 	led_on

	mov r5, #0
	mov r6, #0
	b ReadKeys

/* read keys */
ReadKeys:
	add r6, r6, #1
	cmp r6, #CNT_MAX
	bne KeyA
	mov r6, #0
	bl Clear4Leds
	add r5, r5, #1
	cmp r5, #1
	bne LED_2
LED_1:
	ldr	r0, =GPIOB_BASE
	ldr	r1,=LEDA
	bl 	led_on
	b KeyA
LED_2:
	ldr	r0, =GPIOA_BASE
	cmp r5, #2
	bne LED_3
	ldr	r1,=LEDB
	bl 	led_on
	b KeyA
LED_3:
	cmp r5, #3
	bne LED_4
	ldr	r1,=LEDC
	bl 	led_on
	b KeyA
LED_4:
	cmp r5, #4
	ldr	r1,=LEDD
	bl 	led_on
	mov r5, #0

KeyA:
	ldr	r0, =GPIOA_BASE
	ldr r1, [r0, #PIO_PDSR] /* pio data status */
	and	r2,r1,#KEYA_S1
	cmp r2, #KEYA_S1
	bne KeyB
	b	blinkLooping
	/* b   ReadKeys */
KeyB:
	ldr	r0, =GPIOB_BASE
	ldr r1, [r0, #PIO_PDSR] /* pio data status */
	and	r2,r1,#KEYB_S2
	cmp r2, #KEYB_S2
	bne KeyC
	bl	print_lcd /* print text on LCD */
	mov r5, #0
	mov r6, #0
	b   ReadKeys
KeyC:
	and	r2,r1,#KEYB_S3
	cmp r2, #KEYB_S3
	bne KeyD
/*	mrs r0, CPSR 		/* read active Status */
/*	bic r0, r0, #0x1f 	/* clear lower 5 Bits */
/*	orr r0, r0, #0x13 	/* new mode: Supervisor */
/*	msr cpsr_c, r0 		/* set new mode */
	/* copy app into RAM and return App-entry in R0 */
	bl	copyBootApp
	mov r13,#0x400
	mov pc, r0
	b   ReadKeys
KeyD:
	and	r2,r1,#KEYB_S4
	cmp r2, #KEYB_S4
	bne NoKeys
	b 0x01010000
NoKeys:
	b   ReadKeys


/* flash 8 leds */
blinkLooping:
	ldr	r3, =LED1
	bl 	blinkB
	ldr	r3, =LED2
	bl 	blinkB
	ldr	r3, =LED3
	bl 	blinkB
	ldr	r3, =LED4
	bl 	blinkB
	ldr	r3, =LED5
	bl 	blinkB
	ldr	r3, =LED6
	bl 	blinkB
	ldr	r3, =LED7
	bl 	blinkB
	ldr	r3, =LED8
	bl 	blinkB
	b blinkLooping



