/*************************************************************************************/
/* Create C-Array-file with data from given binary-file				     */
/*************************************************************************************/

#include <stdio.h>

main(int argc, char *argv[])
{
	FILE *fp_in,*fp_out,*fp_outInc;
	long len,i, LOAD_TO, LOAD_RUN;
	int n;
	unsigned long data;

	if (argc != 7)
	{
		printf("Not enough filenames\n");
		printf("Usage: %s boot.bin prog_out inc_out LOAD_TO LOAD_RUN array_name\n",argv[0]);
		printf("boot.bin  : input file\n");
		printf("prog_out  : output file (array)\n");
		printf("inc_out   : output file (defines)\n");
		printf("LOAD_TO   : hex-addr for Flash-App in RAM\n");
		printf("LOAD_RUN  : hex-addr of App-Entry in RAM\n");
		printf("array_name: name for C-Array\n");
		exit(-1);
	}

	if ((fp_in = fopen(argv[1],"rb")) == NULL)
	{
		printf("Error file <%s> cannot be opened for reading\n",argv[1]);
		exit(-1);
	}
	if ((fp_out = fopen(argv[2],"w")) == NULL)
	{
		fclose(fp_in);
		printf("Error file <%s> cannot be opened for output1\n",argv[2]);
		exit(-1);
	}
	if ((fp_outInc = fopen(argv[3],"w")) == NULL)
	{
		fclose(fp_in);
		printf("Error file <%s> cannot be opened for output2\n",argv[3]);
		exit(-1);
	}

	n=sscanf(argv[4],"%lxu",&LOAD_TO);
	if (n!=1) {printf("argument error: LOAD_TO\n");exit(1);}	

	n=sscanf(argv[5],"%lxu",&LOAD_RUN);
	if (n!=1) {printf("argument error: LOAD_RUN\n");exit(1);}	

	fseek(fp_in,0,2);
	len = ftell(fp_in);
	printf("Filelength = %ld\n",len);

	fprintf(fp_outInc,".equ LOAD_TO,  0x%lx\n",LOAD_TO);
	fprintf(fp_outInc,".equ LOAD_RUN, 0x%lx\n",LOAD_RUN);
	fprintf(fp_outInc,".equ LOAD_SIZE,0x%lx\n",len);

	len/=4;
	len++;
	fseek(fp_in,0,0);
	fprintf(fp_out,"#define PROG_ARRAY_SIZE	%d\n",len);

	fprintf(fp_out,"unsigned long %s[PROG_ARRAY_SIZE] = {\n",argv[6]);
	for(i=0;i<len;i++)
	{
		if (i) if (i%5==0) fprintf(fp_out,"\n");
		fread(&data,1,sizeof(data),fp_in);
		fprintf(fp_out,"\t%8.8#lx,",data);

	}
	fprintf(fp_out,"};\n\n");
	fprintf(fp_out,"unsigned long %s_size(){return((unsigned long)PROG_ARRAY_SIZE);}\n", argv[6]);


	fclose(fp_in);
	fclose(fp_out);
	fclose(fp_outInc);
}


