/*****************************************************************************/
/* Add small infoblock before binary-file				     */
/*****************************************************************************/

#include <stdio.h>

main(int argc, char *argv[])
{
	FILE *fp_in,*fp_out;
	long len,i;
	unsigned short data, lo,hi;

	if (argc < 3)
	{
		printf("Not enough filenames\n");
		printf("Usage: gen_sizeinfo f_in f_out\n");
		printf("f_in  : input file\n");
		printf("f_out : output file\n\ncopy lenght-info (hiword+loword=long) before binary-output");
		exit(-1);
	}

	if ((fp_in = fopen(argv[1],"rb")) == NULL)
	{
		printf("Error file <%s> cannot be opened for reading\n",argv[1]);
		exit(-1);
	}
	if ((fp_out = fopen(argv[2],"wb")) == NULL)
	{
		fclose(fp_in);
		printf("Error file <%s> cannot be opened for output\n",argv[2]);
		exit(-1);
	}	
	fseek(fp_in,0,2);
	len = ftell(fp_in);
	fseek(fp_in,0,0);

	
	hi=(unsigned short)( ((len/2)&0xFFFF0000)>>16);
	lo=(unsigned short)((len/2)&0xFFFF);

	printf("--> Filelength = %ld [ %4.4X-%4.4X ]\n",len, hi, lo);

	/* write len */
	fwrite(&hi,1,sizeof(hi),fp_out);
	fwrite(&lo,1,sizeof(lo),fp_out);
	
	for(i=0;i<len/2;i++)
	{
		fread(&data,1,sizeof(data),fp_in);
		fwrite(&data,1,sizeof(data),fp_out);
	}
	fclose(fp_in);
	fclose(fp_out);
}


