.equ STACK_LIMIT,     0xC00	/* 3K */
.equ IRQ_STACK_SIZE,  (4*4)

.equ     I_BIT,	0x80
.equ     F_BIT, 0x40
.equ     T_BIT, 0x20

.equ     ARM_MODE_IRQ,  0x12
.equ     ARM_MODE_SYS,  0x1F

.equ	ARM_MODE_USER,  0x10



	.global	__main
__main:	
	/* Setup the stack for each mode */
	/* Set up Interrupt mode and set IRQ stack */
    	msr         CPSR_c, #ARM_MODE_IRQ|I_BIT|F_BIT
    	mov         r13, #STACK_LIMIT
    	mov         r0, r13
    	sub         r0, r0, #IRQ_STACK_SIZE

	/* Set up the User mode and stack pointer */
    	msr         CPSR_c, #ARM_MODE_SYS|I_BIT|F_BIT /* No interrupts */
    	mov         r13, r0

	/* Setup Application Operating Mode and Enable the interrupts */
    	msr         CPSR_c, #ARM_MODE_USER
    	mov         r13, r0
loop:
	b loop
	nop
	nop


